contravariant-extras-0.3.5.4: Extras for the "contravariant" package

Safe Haskell | None
Language | Haskell2010

Contravariant.Extras

Synopsis

- module Contravariant.Extras.Contrazip
- module Contravariant.Extras.ContrazipLifting
- (>*<) :: Divisible f => f a -> f b -> f (a, b)
- contramany :: Decidable f => f a -> f [a]
- data Supplied (divisible :: Type -> Type) = Supplied (divisible input) input

# Documentation

`contrazip` functions of multiple arities.

module Contravariant.Extras.Contrazip

`contrazipLifting` functions of multiple arities.

module Contravariant.Extras.ContrazipLifting

(>*<) :: Divisible f => f a -> f b -> f (a, b) Source #

An alias to `divided`.

contramany :: Decidable f => f a -> f [a] Source #

data Supplied (divisible :: Type -> Type) Source #

A combination of a divisible functor with some input for it. Allows to use the `Monoid` API for composition.

Constructors

Supplied (divisible input) input |

#### Instances

Instances details

Divisible divisible => Monoid (Supplied divisible) Source # |
Instance details Defined in Contravariant.Extras Methods mempty :: Supplied divisible Source # mappend :: Supplied divisible -> Supplied divisible -> Supplied divisible Source # mconcat :: [Supplied divisible] -> Supplied divisible Source #
Divisible divisible => Semigroup (Supplied divisible) Source # |
Instance details Defined in Contravariant.Extras Methods (<>) :: Supplied divisible -> Supplied divisible -> Supplied divisible Source # sconcat :: NonEmpty (Supplied divisible) -> Supplied divisible Source # stimes :: Integral b => b -> Supplied divisible -> Supplied divisible Source #